const mongoose = require('mongoose');
const { Schema } = mongoose;

const timeEntrySchema = new Schema({
  startTime: { type: Date, required: true },
  endTime: { type: Date, required: true },
  duration: { type: Number, required: true },
  employeeId: { type: Schema.Types.ObjectId, ref: 'Employee' },
  taskId: { type: String, required: true },
  projectId: { type: Schema.Types.ObjectId, ref: 'Project', required: true },
  description: { type: String, required: true },
  date: { type: Date, required: true },
  approved: { type: Boolean, default: false },
  rejected: { type: Boolean, default: false },
  remarks: { type: String },
  history: [{
    employeeId: { type: Schema.Types.ObjectId, ref: 'Employee', required: true },
    status: { type: String, required: true },
    userRole: { type: String, required: true },
    updatedAt: { type: Date, default: Date.now }
  }]

});

const TimeEntry = mongoose.model('TimeEntry', timeEntrySchema);
module.exports = TimeEntry;