const mongoose = require('mongoose');
const { Schema } = mongoose;

const timesheetSchema = new Schema({
  employeeId: { type: Schema.Types.ObjectId, ref: 'Employee', required: true },
  date: { type: Date, required: true },
  entryIds: [{ type: Schema.Types.ObjectId, ref: 'TimeEntry' }],
  submitted: { type: Boolean, default: false },
  approved: { type: Boolean, default: false },
  history: [{
    employeeId: { type: Schema.Types.ObjectId, ref: 'Employee', required: true },
    status: { type: String, required: true },
    userRole: { type: String, required: true },
    updatedAt: { type: Date, default: Date.now }
  }]
});

const Timesheet = mongoose.model('Timesheet', timesheetSchema);
module.exports = Timesheet;