require('dotenv').config();
const express = require('express');
const cors = require('cors');
const connectDB = require('./database/connect');
const routes = require('./routes');
const startCronJobs = require('./utils/crone');
const resourceOnBenchCrone = require('./utils/resourceOnBenchCrone');

const app = express();
const port = process.env.PORT || 9000;

app.use(cors());
app.use(express.json());
app.use('/', routes);

// eslint-disable-next-line no-unused-vars
app.use((err, req, res, next) => {
  console.error(err.stack);
  res.status(500).send('Something went wrong!');
});

connectDB().then(() => {
  app.listen(port, () => {
    console.log(`App listening on port ${port}`);
    startCronJobs();
    resourceOnBenchCrone();
  });
}).catch(err => {
  console.error('Failed to connect to MongoDB', err);
  process.exit(1);
});




