const Employee = require('../../database/models/employeeSchema');

const findUserByEmail = async (email) => {
  return await Employee.findOne({ email }). populate('role');
};


const addRefreshTokenToUser = async (userId, refreshToken) => {
  return await Employee.findByIdAndUpdate(
    userId,
    { $set: { refreshToken: refreshToken } },
    { new: true }
  );
};


const removeRefreshTokenFromUser = async (userId) => {
  return await Employee.findByIdAndUpdate(
    userId,
    { $set: { refreshToken: '' } },
    { new: true }
  );
};


const clearUserRefreshTokens = async (userId) => {
  return await Employee.findByIdAndUpdate(
    userId,
    { $set: { refreshToken: '' } },
    { new: true }
  );
};


module.exports = {
  findUserByEmail,
  addRefreshTokenToUser,
  removeRefreshTokenFromUser,
  clearUserRefreshTokens
};