const express = require('express');
const router = express.Router();
const authController = require('./auth.controller');
const authMiddleware = require('../../middlewares/authMiddleware');

router.post('/login',authController.login);
router.post('/refresh-token', authController.refreshToken); // Remove authMiddleware
router.post('/logout', authMiddleware, authController.logout);
router.post('/password-reset', authController.forgotpassword);
router.post('/password-reset/:id/:token',authController.passwordreset);

module.exports = router;