const reportService = require('../Report/Service/report.service');

const getEmployeeTimeLogs = async (req, res) => {
  try {
    const { employeeId } = req.params;
    const { projectId, start, end } = req.query;

    const timeLogs = await reportService.getEmployeeTimeLogs(employeeId, projectId, start, end);

    res.status(200).json(timeLogs);
  } catch (error) {
    res.status(500).json({ message: error.message });
  }
};

const getProjectTasks = async (req, res) => {
  try {
    const { projectId } = req.params;
    const tasks = await reportService.getProjectTasks(projectId);
    res.json(tasks);
  } catch (error) {
    console.error('Error in getProjectTasks:', error);
    res.status(500).json({ message: 'Internal server error' });
  }
};


module.exports = {
  getEmployeeTimeLogs,
  getProjectTasks
};