const skillsetService = require('./Services/skillset.service');

const getSkillsetByID = async (req, res) => {
  try {
    const id = req.params.id;
    const skillset = await skillsetService.getSkillsetID(id);
    res.json(skillset);
  } catch (error) {
    res.status(500).send('Server error');
  }
};

const getSkillset = async (req, res) => {
  try {
    const { search, page = 1, limit = 10 } = req.query;  
    const skillset = await skillsetService.getSkillset(search, page, limit);
    res.json(skillset);
  } catch (error) {
    res.status(500).send('Server error');
  }
};


const addSkillset = async (req, res) => {
  try {
    const newSkillset = await skillsetService.addSkillset(req.body);
    res.json(newSkillset);
  } catch (error) {
    res.status(500).send('Server error');
  }
};

const editSkillset = async (req, res) => {
  try {
    const updatedSkillset = await skillsetService.editSkillset(req.params.id, req.body);
    res.json(updatedSkillset);
  } catch (error) {
    res.status(500).send('Server error');
  }
};

const deleteSkillset = async (req, res) => {
  try {
    await skillsetService.deleteSkillset(req.params.id);
    res.send('Skillset deleted');
  } catch (error) {
    res.status(500).send('Server error');
  }
};

module.exports = {
  getSkillset,
  addSkillset,
  editSkillset,
  deleteSkillset,
  getSkillsetByID
};