const extensionRepository = require('../extension.repository');

const createExtensionRequest = async (extensionData, userRole) => {
  extensionData.history = [{
    status: 'pending',
    userRole: userRole
  }];
  return await extensionRepository.createExtensionRequest(extensionData);
};

const getPendingExtensions = async (search, page, limit, fetchAll = false) => {
  return await extensionRepository.findAllPendingExtensions(search, page, limit, fetchAll);
};

const updateExtensionStatus = async (id, status, userRole) => {
  return await extensionRepository.updateExtensionStatus(id, status, userRole);
};

const getExtensionHistoryByProjectId = async (projectId) => {
  return await extensionRepository.getExtensionHistoryByProjectId(projectId);
};

const getPendingExtensionsByProjectId = async (projectId) => {
  return await extensionRepository.getPendingExtensionsByProjectId(projectId);
};

module.exports = {
  createExtensionRequest,
  getPendingExtensions,
  updateExtensionStatus,
  getExtensionHistoryByProjectId,
  getPendingExtensionsByProjectId
};