const teamMemberRepository = require('../projectTeamMember.repository');

const getProjectTeamMembers = async () => {
  return await teamMemberRepository.findAll();
};

const getProjectTeamMemberById = async (id) => {
  return await teamMemberRepository.findById(id);
};

const getProjectTeamMembersByProjectId = async (projectId, search, page, limit) => {
  return await teamMemberRepository.findByProjectId(projectId, search, page, limit);
};

const addProjectTeamMember = async (teamMemberData) => {
  return await teamMemberRepository.create(teamMemberData);
};

const editProjectTeamMember = async (id, teamMemberData) => {
  return await teamMemberRepository.updateById(id, teamMemberData);
};


const deleteProjectTeamMember = async (id) => {
  return await teamMemberRepository.deleteById(id);
};

module.exports = {
  getProjectTeamMembers,
  getProjectTeamMemberById,
  getProjectTeamMembersByProjectId,
  addProjectTeamMember,
  editProjectTeamMember,
  deleteProjectTeamMember
};
